

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>posydon.visualization.VH_diagram.MainWindow &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../../" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/jquery.js"></script>
        <script src="../../../../_static/underscore.js"></script>
        <script src="../../../../_static/doctools.js"></script>
        <script src="../../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
        
      <li>posydon.visualization.VH_diagram.MainWindow</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for posydon.visualization.VH_diagram.MainWindow</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">PyQt5.QtWidgets</span> <span class="kn">import</span> <span class="n">QMainWindow</span><span class="p">,</span> <span class="n">QScrollArea</span><span class="p">,</span> <span class="n">QApplication</span><span class="p">,</span> <span class="n">QMenuBar</span>
<span class="kn">from</span> <span class="nn">PyQt5.QtCore</span> <span class="kn">import</span> <span class="n">pyqtSignal</span>

<span class="kn">from</span> <span class="nn">.GraphVisualizer</span> <span class="kn">import</span> <span class="n">GraphVisualizer</span><span class="p">,</span> <span class="n">PointInfos</span><span class="p">,</span> <span class="n">CaseInfos</span>
<span class="kn">from</span> <span class="nn">.OptionsWindow</span> <span class="kn">import</span> <span class="n">OptionsWindow</span>

<span class="c1"># Indirection layer to combine options and widget</span>
<span class="c1"># Options&#39;s signals maybe replaced by Obvsevable pattern</span>
<div class="viewcode-block" id="VisualizerInterface"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.VisualizerInterface">[docs]</a><span class="k">class</span> <span class="nc">VisualizerInterface</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Handle for all callback triggered by user&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">main_win</span><span class="p">,</span> <span class="n">visualizer</span><span class="p">,</span> <span class="n">options</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Short summary.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        main_win : MainWindow</span>
<span class="sd">            The main window used.</span>
<span class="sd">        visualizer : GraphVisualizer</span>
<span class="sd">            Custom widget to display graph.</span>
<span class="sd">        options : OptionsWindow</span>
<span class="sd">            Window used to display options.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_main_win</span> <span class="o">=</span> <span class="n">main_win</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_visualizer</span> <span class="o">=</span> <span class="n">visualizer</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_options</span> <span class="o">=</span> <span class="n">options</span>

    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_visualizer</span>

<div class="viewcode-block" id="VisualizerInterface.detail_required"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.VisualizerInterface.detail_required">[docs]</a>    <span class="k">def</span> <span class="nf">detail_required</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_options</span><span class="o">.</span><span class="n">detail_requiered</span></div>

<div class="viewcode-block" id="VisualizerInterface.reduce_required"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.VisualizerInterface.reduce_required">[docs]</a>    <span class="k">def</span> <span class="nf">reduce_required</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_options</span><span class="o">.</span><span class="n">reduce_required</span></div>

<div class="viewcode-block" id="VisualizerInterface.simplify_required"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.VisualizerInterface.simplify_required">[docs]</a>    <span class="k">def</span> <span class="nf">simplify_required</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_options</span><span class="o">.</span><span class="n">simplify_required</span></div>

<div class="viewcode-block" id="VisualizerInterface.diagram_required"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.VisualizerInterface.diagram_required">[docs]</a>    <span class="k">def</span> <span class="nf">diagram_required</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_options</span><span class="o">.</span><span class="n">diagram_required</span></div>

<div class="viewcode-block" id="VisualizerInterface.save_required"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.VisualizerInterface.save_required">[docs]</a>    <span class="k">def</span> <span class="nf">save_required</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_main_win</span><span class="o">.</span><span class="n">save_requiered</span></div>

<div class="viewcode-block" id="VisualizerInterface.distance_representation_required"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.VisualizerInterface.distance_representation_required">[docs]</a>    <span class="k">def</span> <span class="nf">distance_representation_required</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_options</span><span class="o">.</span><span class="n">distance_representation_required</span></div>

<div class="viewcode-block" id="VisualizerInterface.options"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.VisualizerInterface.options">[docs]</a>    <span class="k">def</span> <span class="nf">options</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_options</span></div></div>


<div class="viewcode-block" id="MainWindow"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.MainWindow">[docs]</a><span class="k">class</span> <span class="nc">MainWindow</span><span class="p">(</span><span class="n">QMainWindow</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Custom window to display the application&quot;&quot;&quot;</span>

    <span class="n">save_requiered</span> <span class="o">=</span> <span class="n">pyqtSignal</span><span class="p">()</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">MainWindow</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">setWindowTitle</span><span class="p">(</span><span class="s2">&quot;Simulation visualisation&quot;</span><span class="p">)</span>

        <span class="n">screen_geometry</span> <span class="o">=</span> <span class="n">QApplication</span><span class="o">.</span><span class="n">desktop</span><span class="p">()</span><span class="o">.</span><span class="n">screenGeometry</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">resize</span><span class="p">(</span><span class="n">screen_geometry</span><span class="o">.</span><span class="n">width</span><span class="p">()</span> <span class="o">*</span> <span class="mf">0.66</span><span class="p">,</span> <span class="n">screen_geometry</span><span class="o">.</span><span class="n">height</span><span class="p">()</span> <span class="o">*</span> <span class="mf">0.66</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">_visualizer</span> <span class="o">=</span> <span class="n">GraphVisualizer</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_option_window</span> <span class="o">=</span> <span class="n">OptionsWindow</span><span class="p">()</span>

<div class="viewcode-block" id="MainWindow.start_visualition"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.MainWindow.start_visualition">[docs]</a>    <span class="k">def</span> <span class="nf">start_visualition</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Short summary.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        VisualizerInterface</span>
<span class="sd">            Return the interface with current window, binded visualizer widget and option window. Expose callbacks</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">scroll_area</span> <span class="o">=</span> <span class="n">QScrollArea</span><span class="p">()</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">scroll_area</span><span class="o">.</span><span class="n">setWidget</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_visualizer</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">scroll_area</span><span class="o">.</span><span class="n">setWidgetResizable</span><span class="p">(</span><span class="kc">True</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">setCentralWidget</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">scroll_area</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">_setup_visualizer_option</span><span class="p">()</span>

        <span class="k">return</span> <span class="n">VisualizerInterface</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">_visualizer</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">_option_window</span><span class="p">)</span></div>

    <span class="k">def</span> <span class="nf">_setup_visualizer_option</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Prepare all displayed option on MenuBar&quot;&quot;&quot;</span>

        <span class="n">bar</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">menuBar</span><span class="p">()</span>
        <span class="n">bar</span><span class="o">.</span><span class="n">setNativeMenuBar</span><span class="p">(</span><span class="kc">False</span><span class="p">)</span>
        <span class="n">option_action</span> <span class="o">=</span> <span class="n">bar</span><span class="o">.</span><span class="n">addAction</span><span class="p">(</span><span class="s2">&quot; &amp;Options&quot;</span><span class="p">)</span>
        <span class="n">option_action</span><span class="o">.</span><span class="n">triggered</span><span class="o">.</span><span class="n">connect</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_show_option_window</span><span class="p">)</span>

        <span class="n">option_action</span> <span class="o">=</span> <span class="n">bar</span><span class="o">.</span><span class="n">addAction</span><span class="p">(</span><span class="s2">&quot; &amp;Save&quot;</span><span class="p">)</span>
        <span class="n">option_action</span><span class="o">.</span><span class="n">triggered</span><span class="o">.</span><span class="n">connect</span><span class="p">(</span><span class="k">lambda</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">save_requiered</span><span class="o">.</span><span class="n">emit</span><span class="p">())</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">setMenuBar</span><span class="p">(</span><span class="n">bar</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">_show_option_window</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">_</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_option_window</span><span class="o">.</span><span class="n">showNormal</span><span class="p">()</span>

<div class="viewcode-block" id="MainWindow.closeEvent"><a class="viewcode-back" href="../../../../api/posydon.visualization.VH_diagram.MainWindow.html#posydon.visualization.VH_diagram.MainWindow.MainWindow.closeEvent">[docs]</a>    <span class="k">def</span> <span class="nf">closeEvent</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">event</span><span class="p">):</span> <span class="c1"># Override closeEvent of QWidget</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_option_window</span><span class="o">.</span><span class="n">close</span><span class="p">()</span></div></div>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>